
// **************************************************************************
// hdos free space handling routines
// **************************************************************************

#include "hdstr.h"
#include "hfree.h"
#include "hmalloc.h"
#include "hlow.h"
#include "hdio.h"
#include <string.h>
#include "hfile.h"

s_fsam *myavl;


long getnextsector()
// return the number of the next free sector from the free list
// and remove it from the free list
{
 long se,next,prev;
 int i;
 s_dir  *mydir;

 if (myavl) 
 {
	 se = myavl->f_myadr;
 }
 else
 {
	 if ((myavl = calloc(1,sizeof(s_fsam))) == 0)
	     hderror(OUTOFMEMORY);
 
	 se=AVLSTART;
 }
 do
 {
  if (se != myavl->f_myadr) hdread(myavl,se);
  for (i=0;i<n_run;i++)
  {
   next = myavl->f_runst[i];
   if (next) // this one is not zero
   {
    myavl->f_runst[i]++;
    myavl->f_dirty=dirty;

    if (myavl->f_runst[i] > myavl->f_runen[i])
     {
      myavl->f_runst[i] = 0;
      myavl->f_runen[i] = 0;	  	 
     }

    if (!filesopen)
     {    
    	flushfsam(myavl);
     	free(myavl);
     	myavl=0;
     }
    return(next);
   }
  }
  flushfsam(myavl);
  se = myavl->f_next;  
 } while (se);
 // gone past end of free list and found no free sectors
 // so look for the first erased file

 if ((mydir = calloc(1,sizeof(s_fsam))) == 0)
     hderror(OUTOFMEMORY);
 
 se = DIRSTART;
 do
 {
  hdread(mydir,se);
  se = mydir->d_next;
  for (i=0;i<n_head;i++)
  {
   if (mydir->d_head[i].h_dir == removed) // found an erased entry
   {
    // make last free-chain fsam point to erased file fsam
    myavl->f_next  = mydir->d_head[i].h_fsam;
    myavl->f_dirty = dirty;
    prev = myavl->f_myadr; // store this adress
    flushfsam(myavl);

    // make erased file fsam point back to free chain
    hdread(myavl,mydir->d_head[i].h_fsam);
    memset(&myavl->f_fib,0,sizeof(s_fib)); 
    myavl->f_prev  = prev;
    myavl->f_dirty = dirty;
    flushfsam(myavl);

    // and erase old file dir entry
    mydir->d_head[i].h_dir  = 0;
    mydir->d_head[i].h_fsam = 0;
    mydir->d_dirty = dirty;
    flushdir(mydir);
    free(myavl);
    myavl=0;
    free(mydir);
//  printf("\rWarning. Disk is fragmented.\r");
    return(getnextsector());
   }
  }
 } while (se);
 free(myavl);
 myavl=0;
 free(mydir);
 if (filesopen)
 { // close all files
	 uint hand;
	 for (hand=0;hand<16;hand++)
	 hclose(hand);
 }
 hderror(DISKFULL);
 return(crash);  // actually will not return from hderror
}

// **************************************************************************
// end of free space handling routines
// **************************************************************************
