
// source for hdos mkdir etc routines

#include "hdstr.h"
#include "hmkdir.h"
#include "hdir.h"
#include "hlow.h"
#include "hmalloc.h"
#include <string.h>
#include "hfname.h"
#include "hdio.h"
#include "hfile.h"

int chdir(char *path)
// change to directory path. path should end with / and be null terminated
{
 int newdir;

 if ((newdir = getdirnum(path)) != error) 
 {
  currdir = newdir;
  return(newdir);
 }
 else
  hderror(BADPATH);
 return(currdir);
}

int rmdir(char *path)
// remove directory
{
 //
 int count;
 char *pp;

 if (!(pp = calloc(1,8+strlen(path)))) 
 {
	 hderror(OUTOFMEMORY);
 }
 strcpy(pp,path);
 pp[strlen(pp)]=wild2;  // add / to end of path
 
 if (getdirnum(pp)==0) 
 {
	 free(pp); 
	 return(ok); // do not remove root !
 }
 
 count = hddirfunc(pp,8);

 if (count == error) 
 {
	 free(pp);
	 return(error); // bad path reported by hddirfunc
 }

 if (count != 2) 
 {
  free(pp);	 
  hderror(NOTEMPTY);
 }

 strcpy(pp,path);
 pp[strlen(pp)]=wild2;
 hddirfunc(pp,5);
 hddirfunc(pp,0);

 strcpy(pp,path);
 pp[strlen(pp)-1]=0;
 hddirfunc(pp,5);	 
 hddirfunc(pp,0);	 
 free(pp);
 return(ok);
}


// mkdir chdir & rmdir should be consistant and not need a / on the end

void mkdir(char *path)
// make a new dir path. path should be a null terminated string ending in
// the name of the new path eg. this/that/theother/newone
{
 //
 int tmpdir,newdir,dirnum;
 s_label *mylab;
 char *pp,extn[8];
 s_fsam  *myfsam;
 
 
 // store currdir;
 dirnum = currdir;
 
 // get parent dirnum
 if (( tmpdir = getdirnum(path)) == error) 
 {
	 return;
 }

 if ((mylab = calloc(1,sizeof(s_dir))) == 0) hderror(OUTOFMEMORY);
 // get new child dirnum
 hdread(mylab,LABEL);
 newdir = ++mylab->l_lastdir;
 hdwrite(mylab,LABEL);
 free(mylab);
 
 if (creat(path) == ok)
 {
  if ((myfsam = calloc(1,sizeof(s_fsam))) == 0) hderror(OUTOFMEMORY);
  getfsam(path,myfsam);
  myfsam->f_fib.f_type = (ft_Hdir | ft_protected);
  myfsam->f_fib.f_info.u_dirinfo.dirnum = newdir;
  myfsam->f_dirty = dirty;
  flushfsam(myfsam);
 
  if ((pp = calloc(1,strlen(path)+6)) == 0) hderror(OUTOFMEMORY);
  strcpy(pp,path);
  extn[0]=dirsep;
  extn[1]='.';
  extn[2]=0;
  strcat(pp,extn);
  if ((creat(pp)) == error)
  {
	goto mkend;  
  }
  getfsam(pp,myfsam);
  myfsam->f_fib.f_type = (ft_Hdir |ft_protected |ft_hidden);
  myfsam->f_fib.f_info.u_dirinfo.dirnum = newdir;
  myfsam->f_dirty = dirty;
  flushfsam(myfsam);

  strcpy(pp,path);
  extn[0]=dirsep;
  extn[1]='.';
  extn[2]='.';
  extn[3]=0;
  strcat(pp,extn);
  if ((creat(pp)) == error) 
  {
	goto mkend;;  // make dir ..
  }
  getfsam(pp,myfsam);
  myfsam->f_fib.f_type = (ft_Hdir |ft_protected |ft_hidden);
  myfsam->f_fib.f_info.u_dirinfo.dirnum = tmpdir;
  myfsam->f_dirty = dirty;
  flushfsam(myfsam);
mkend:
  free(myfsam);
  free(pp);
 }
}
