
// **************************************************************************
// sam io routines 
// **************************************************************************

#include "hsamio.h"

volatile unsigned char * curstrm @ 0x5AB2;
volatile unsigned char * lastkey @ 0x5C01;

short pushback = 0;

void outch(char chr) // print chr on current stream 
{
// chr will be passed in DE	
#asm
 LD A,E
 PUSH IY
 RST 10h
 POP IY
#endasm
}

char inch() // get a character from the current stream
{
#asm
	PUSH BC
	PUSH DE
	PUSH IX
	PUSH IY
	LD HL,_backfrominpc
	PUSH HL  ; set return address
	LD HL,(0x5C51)
	INC HL
	INC HL
	LD A,(HL)
	INC HL
	LD H,(HL)
	LD L,A	; HL HAS ADDRESS OF INPUT ROUTINE
	JP (HL)
_backfrominpc:
	LD H,0  
	LD L,A  ; store char in HL for RET
	POP IY
	POP IX
	POP DE
	POP BC
	RET
#endasm
	return(0);	// won't ever get to here
}
	
void setstream(int strno)
{

#asm 
 ld a,(0x5ab2)
 cp e
 jr z,1f
 ld a,e
 push hl
 CALL 0x0112
 pop hl
1: 
#endasm
}

void clrscr(void)
{
#asm 
 XOR A
 CALL 0x014E
#endasm 
}

void pause(int frames)
{ // assumes interupts are enabled else you'll hang
 for (;frames > 0;frames--) asm("HALT");
}

void ungetch(char c)
{
	pushback = c;
}

short kbhit(void)
{
	return (*lastkey != 0);
}

char getch(void)
// get a character from the keyboard
{
	short	c;

	if (c = pushback) {
		pushback = 0;
		return c;
	}
	setstream(2);
	return(inch());
}

void putch(char ch)
{
	setstream(2);
	outch(ch);
}


char getche(void)
{
	char chr;

	while ((chr = getch()) == 0);
	putch(chr);
	return(chr);
}

